(function(){
    app.ctx = "";
	app.location = window.location;
	app.curWwwPath = "";
	/**
	 * 例http://127.0.0.1:8080/thunisoft-app/thunisoft/webapp/html-index?
	 * location.origin = http://127.0.0.1:8080
	 * location.protocol = http
	 * location.host = 127.0.0.1:8080
	 * location.port = 8080
	 * location.hostname = 127.0.0.1
	 * location.pathname = /thunisoft-app/thunisoft/webapp/html-index
	 * location.search = 比如：	?search=str
	 * location.hash = 锚点 比如：#anchor
	 * */
	with(app){
		app.curWwwPath = location.href;
		var pathName =  location.pathname;
		var projectName = pathName.substring(0, pathName.substr(1).indexOf('/')+1);
		var originName = location.origin;
		if(originName){
			if(projectName.indexOf("\/", 0)>=0){
				ctx = originName + projectName;
			}else{
				ctx = originName + "/" + projectName;
			}
		}else{
			var pos = app.curWwwPath.indexOf(pathName);
			var localhostPath = app.curWwwPath.substring(0,pos);
			ctx = localhostPath + projectName;
		}
	}
	/**
	 * 浏览器信息
	 */
	app.browser={
	    versions:function(){
	        var u = navigator.userAgent, app = navigator.appVersion;
	        return {
	            trident: u.indexOf('Trident') > -1, //IE内核
	            presto: u.indexOf('Presto') > -1, //opera内核
	            webKit: u.indexOf('AppleWebKit') > -1, //苹果、谷歌内核
	            gecko: u.indexOf('Gecko') > -1 && u.indexOf('KHTML') == -1,//火狐内核
	            mobile: !!u.match(/AppleWebKit.*Mobile.*/), //是否为移动终端
	            ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), //ios终端
	            android: u.indexOf('Android') > -1 || u.indexOf('Linux') > -1, //android终端或者uc浏览器
	            iPhone: u.indexOf('iPhone') > -1 , //是否为iPhone或者QQHD浏览器
	            iPad: u.indexOf('iPad') > -1, //是否iPad
	            webApp: u.indexOf('Safari') == -1, //是否web应该程序，没有头部与底部
	            weixin: u.indexOf('MicroMessenger') > -1, //是否微信 （2015-01-22新增）
	            qq: u.match(/\sQQ/i) == " qq" //是否QQ
	        };
	    }(),
	    language:(navigator.browserLanguage || navigator.language).toLowerCase()
	};
    /**
      * 临时方案,详情看android的webview加载
      */
    if(!window.happ){
        var u = navigator.userAgent;
        window.happ = {
            agent: u.indexOf("HappAndroid")>-1?"android":"other"
        };
    }
    /**
     * 地址作为参数，并且自己带参数，避免混乱，以此代替&作为分词
     */
    app.argument_separator = "$_$";
    /**
     * 跳转
     */
    app.forward = function(abslotueUrl){
        var index = 0;
        var href = app.ctx + abslotueUrl;
        do{
            index++;
            if(arguments[index] != null){
                if(index == 1){
                    href += "?" + encodeURI(arguments[index]);
                }else{
                    href += "&" + encodeURI(arguments[index]);
                }
            }
        }while(arguments.length > index);
        window.location.href =  href;
    };
    /**
     * 页面跳转参数传递，使用此方法
     * 跳转页面使用?arg1=33&arg2=test
     * 则GetExtraString(arg1)或者GetExtraString(arg2)
     * */
    app.getExtraString = function(name, split){
        if(split){
            var search = decodeURI(app.location.search);
             var r = search.substr(1).split(split);
             if(r == null){
                 return null;
             }
             for(var i=0;i<r.length;i++){
                 var args = r[i].split("=");
                 if(args[0] == name){
                     return args[1];
                 }
             }
             return null;
        }else{
            var reg = new RegExp("(^|&)"+ name +"=([^&]*)(&|$)");
            var search = decodeURI(app.location.search);
             var r = search.substr(1).match(reg);
             if(r!=null){
                 return  unescape(r[2]);
             }
             return null;
        }
    };
})();
/**
 * 数据缓存
 */
(function(){
	app.sessionStorage = function(url, data){
		sessionStorage.setItem(url, JSON.stringify(data));
	};
	app.getSessionStorage = function(url){
		if(!url){
			url = app.location.href;
		}
		return sessionStorage.getItem(url);
	};
	app.localStorage = function(url, data){
		localStorage.setItem(url, JSON.stringify(data));
	};
	app.getLocalStorage = function(url){
		if(!url){
			url = app.location.href;
		}
		return localStorage.getItem(url);
	};
})();
/**
 * 系统操作事件的监听backPress、menuPress 等。	定义接口、规则，交由 android或者ios的js类库实现
 */
(function(){
	app.EventListenersType = {//@See XWebJsBridge.JsCallBack
		HtmlOnResume:"htmlResume",
		HtmlOnStop:"htmlStop",
		BackPress:"backPress",
		SettingPress:"settingPress",
		FileChoose:"fileChoose",
		VoiceListener:"voiceListener",
		CollectListener:"collectListener",
		NetworkStatusListener:"networkStatusListener"
	};
	/**
	 * 监听Callback缓存
	 */
	app.eventListeners = {
		htmlOnResume:{},
		htmlOnStop:{},
		backPress:{},
		settingPress:{},
		fileChoose:{},
		voiceListener:{},
		collectListener:{},
		networkStatusListener:{}
	};
	/**
	 * 事件监听参数定义
	 */
	app.eventListenerParams = {
			type:"",//监听工作类型，见app.EventListenersType
			dataType:"json",//默认json
			data:"",//传参
			url:"",//注册事件的唯一key，默认支持一个地址只支持一次同类型(type)的事件
			title:"",//弹出框title,only for BackPress
			message:"",//弹出框提示内容,only for BackPress
			callback:function(){},//通用注册监听的回调，for all
			positiveButton:{text:"",click:function(){}},//弹出框确认按钮响应回调,only for BackPress
			negativeButton:{text:"",click:function(){}}//弹出框取消按钮响应回调,only for BackPress
	};
	app.checkEventListener = function(type){};
	app.sysDoEventListener = function(type){};
	app.addEventListener = function(params, bubble){};
	app.removeEventLisenter = function(type,url){
		if(type == app.EventListenersType.BackPress){
			if(app.eventListeners.backPress[url]){
				delete app.eventListeners.backPress[url];
			}
		}else if(type == app.EventListenersType.SettingPress){
			if(app.eventListeners.settingPress[url]){
				delete app.eventListeners.settingPress[url];
			}
		}else if(type == app.EventListenersType.HtmlOnResume){
			if(app.eventListeners.htmlOnResume[url]){
				delete app.eventListeners.htmlOnResume[url];
			}
		}else if(type == app.EventListenersType.HtmlOnStop){
			if(app.eventListeners.htmlOnStop[url]){
				delete app.eventListeners.htmlOnStop[url];
			}
		}else if(type == app.EventListenersType.FileChoose){
			if(app.eventListeners.fileChoose[url]){
				delete app.eventListeners.fileChoose[url];
			}
		}else if(type == app.EventListenersType.VoiceListener){
			if(app.eventListeners.voiceListener[url]){
				delete app.eventListeners.voiceListener[url];
			}
		}else if(type == app.EventListenersType.CameraListener){
			if(app.eventListeners.CameraListener[url]){
				delete app.eventListeners.CameraListener[url];
			}
		}else{
			console.log("remove时，没有支持" + params.type + "的监听");
		}
	};
})();
/**
 * 页面加载pushState、sessionStorage、页面间传参。定义接口、规则，交由 android或者ios的js类库实现
 */
(function(){
	/**
	 * pushState数据结构。
	 * 设计灵魂：KV设计、只使用pushState的地址栏变化特性。
	 * 一切皆受url控制（即url为所有pager中唯一标识），app唯一全局对象中存储pager相关信息都是以url为key值。
	 */
	app.getStateObj = function(type){
		return {
			type:"pager OR router",
			url:app.location.href
		};
	}
	/**
	 * singlePage路由 内嵌页面 不重置window、app。定义接口、规则，交由 android或者ios的js类库实现
	 * pager生命周期：createPager>pager>pagerSettings.success||pagerSettings.error
	 * >pagerPushPage>stateSettingsParam>pagerRequestParams>htmlOnStop>afterPager>pagerPopPage
	 * >htmlOnResume
	 */
	app.createPager = function(container){};//想使用pager组件，必须在首页中执行一次该方法，因为首页不是pushState方式打开，所以不会响应popState
	app.pager = function(container, pagerSettings){};//pager组件核心方法
	app.pagerRequestParams = function(url, data){
		if(!url){
			url = app.location.href;
		}
		if(data){//set
			app.sessionStorage(url, data);
		}else{//get
			return app.getSessionStorage(url);
		}
	};
	app.afterPager = function(){};//pager加载完成回调
	app.pagerCompleted = function(completed){//留用
		if(!app.pagerCompletedMap){
			app.pagerCompletedMap = {};
		}
		if(completed){
			app.pagerCompletedMap[app.location.href] = completed;
		}else{
			app.pagerCompletedMap[app.location.href]();
		}
	}
	app.pagerPopPage = function(container){};//弹出pager实现动画效果，popState时
	app.pagerPushPage = function(container, responseText){};//加载pager实现动画效果，pushState时
	app.pagerStartPopState = function(){//启动popState监听
		/**
		 * 监听单页面popState
		 */
		window.addEventListener("popstate", function() {
            var pushedState = history.state;
            if(pushedState != null && null == pushedState.id){
                if(pushedState.type != "pager"){
                    return;
                }
                var pagerSettingsUrl = pushedState.url;
                var pagerSettings = app.stateSettingsParam(pagerSettingsUrl)
                var title = pagerSettings.title;
                var titleLL = $('title');
                titleLL.text(title);
                app.pagerPopPage(pagerSettings.container);
            }else{
                var stateSetting = app.stateSettingsParam();
                app.pagerPopPage(stateSetting.container);
            }
        });
	}
	/**
	 * 路由 切换页面 重置window 、app。		定义接口、规则，交由 android或者ios的js类库实现
	 */
	app.router = function(routerSettings){};
	app.setRouterRequestParams = function(url, data){
		app.localStorage(url, data);
	};
	app.getRouterRequestParams = function(url){
		app.getLocalStorage(url);
	};
	app.routerPopPage = function(url){};
	app.routerPushPage = function(url){};
	app.routerPopState = function(){
		window.addEventListener("popstate", function() {
			//alert("routerPopState");
		});
	}
	/**
	 * 全局持久化pushState的stateSettings，KV（url:stateSettings）
	 */
	app.stateSettingsParams = {date:new Date()};
	app.stateSettingsParam = function(url, stateSettings){
		if(!url){
			url = app.location.href;
		}
		if(stateSettings){//set
			app.stateSettingsParams.date = new Date();
			app.stateSettingsParams[url] = stateSettings;
		}else{//get
			return app.stateSettingsParams[url];
		}
	}
	/**
	 * Pager跳转的默认参数设置
	 */
	app.stateSettings = {
		pushState:false,//ture表示使用window.history.pushState，false表示使用window.history.replaceState；默认使用replace
        title: "",//标识用
        pageUrl:"",//要加载的页面
        /**加载成功或者失败时，处理函数
        success:function(responseText, stateSettings){},
        error:function(error, stateSettings){},
        */
        data:null,//页面跳转传递参数
        dataType:"json",//页面跳转传递参数类型，默认json
        popData:null,//留用
        popDataType:"json",//留用
        /**
         * 放弃此种用法，采用重写app.pagerPopPage = function(){}方式
         * //回到pageUrl时处理函数,建议做一些从pageUrl回到上级一时，需要做的事，很少使用到，
         * 举例，section1-》section2-》section3，返回到2时，处理一些从2返回到1所需要做的事
        popState:function(args){alert(args);}
        */
		state: null//留用
	};
    /**
     */
    app.routerType = {
                /* 首页，纵向排列 */
                ROUTER_JS_PORTAL_LINEAR:"router_js_portal_linear",
                /* 首页，nav在上content在下遮盖 */
                ROUTER_JS_PORTAL_FRAME:"router_js_portal_frame",
                /* 非主页，纵向排列 */
                ROUTER_JS_LINEAR:"router_js_linear",
                /* 非主页，nav在上content在下遮盖 */
                ROUTER_JS_FRAME:"router_js_frame",
                /* 默认容器，脱管旋转 */
                ROUTER_JS_DEFAULT:"router_js_default",
                /* 默认容器，脱管portrait */
                ROUTER_JS_DETACHED_PORTRAIT:"router_js_detached_portrait",
                /* 默认容器，脱管landscape */
                ROUTER_JS_DETACHED_LANDSCAPE:"router_js_detached_landscape",
                /* 浏览器 */
                ROUTER_JS_CHROME:"router_js_chrome",
    //        softInput_Router : "softInput_Router",//多功能router
    //        softInputActivity : "softInput_Router" // 带语音键盘容器
        };
	/**
     * Router跳转的默认参数设置
     */
    app.routerSettings = {
        activity:app.routerType.ROUTER_JS_LINEAR,//容器名称，如果此属性不显示制定则，选择ROUTER_JS_LINEAR
        pushState:"_self",//跳转类型，_self为打开新容器，_blank为打开新容器同时关闭原容器，默认是_self
        title: "",//标识用
　      url:"",//要加载的页面
        data:null,//页面跳转传递参数
        dataType:"json",//页面跳转传递参数类型，目前只支持json
        popData:null,//留用
        popDataType:"json",//留用
        state: null//留用
    };
})();
/**
 */
(function(){
	app.photoSliderType = {
		PHOTO : "photo",
		ANY : "any"
	};
	app.photoSliderParams = {
		sliderType:app.photoSliderType.PHOTO,//
		sliders:[{}],						//
		current:0							//当前显示从0计数
	};
	app.photoType = {
        IAMGE : "image/*",
        ANY : "any"
    };
	app.photoParams = {
        mimeType:app.photoType.IAMGE,//
        uriStr:"",
        title:"",
        subTitle:"",
        description:""
    };
})();
/**
 * 语音识别组件
 */
(function(){
	/**
	 * 语音识别类别
	 */
	app.voiceType = {
		TYPE_ALI_INSIDE_NETWORK : "0",  //阿里内网
		TYPE_ALI_OUTSIDE_NETWORK : "1", //阿里外网
		TYPE_XUNFEI_OUTSIDE_NETWORK : "2"//讯飞外网
	};
})();
/**
 * 定位组件模式
 */
(function(){
	/**
	 * 定位组件模式
	 */
	app.locationType = {
		HIGHT_ACCURACY : "0",  //高性能
		BATTERY_SAVING : "1", //低功耗模式
		DEVICE_SENSORS : "2"//仅设备模式
	};
})();
/**
 * 文件组件
 */
(function(){
	/**
	 * 文件存在组件调用参数列表
	 */
	app.fileExistType = {
		DOWNLOAD : "download",
		ANY : "any"
	};
	app.fileExistParams = {
		fileType:app.fileExistType.ANY,//
		uniqueKey:"",//唯一标识
		fileExt:"",//文件后缀名
		fileName:"",//文件名称
		jsCallback:"",//
        callbackParams:{},//
	};
	/**
	 * 文件存在组件callback回参增加
	 */
	app.fileExistCallbackParams = {
		exist:false,//文件存在标识 默认false不存在，true存在
		totalSize:"",//文件大小
	};
	/**
	 * 文件打开组件调用参数列表
	 */
	app.fileOpenType = {
		DOWNLOAD : "download",
		ANY : "any"
	};
	app.fileOpenParams = {
		fileType:app.fileOpenType.ANY,//
		uniqueKey:"",//唯一标识
		fileExt:"",//文件后缀名
		fileName:"",//文件名称
	};
	app.fileChooseParams = {
		fileType:"fileType",	//选择文件的类型,就是fileChooseType中的对象
		needFileStream:"needFileStream"	//判断是否需要文件流，此字段只适用于图片，文件类型不支持，直接传true和false就可以
	};
	app.fileChooseType = {
	    SHOOT : "image/shoot", //拍照
	    SHOOT_CROP : "image/shoot->crop", //拍照 ->剪切
	    PICTURE : "image/picture", //相册
	    SHOOT_FILE : "image/shoot|file/*",
	    PICTURE_CROP : "image/picture->crop", //相册 ->剪切
	    SHOOT_PICTURE : "image/shoot|picture", //拍照|相册
	    SHOOT_PICTURE_CROP : "image/shoot|picture->crop", //拍照|相册 ->剪切
	    FILE_ALL : "file/*" //所有文件
	};
	app.fileChooseExtraInfo = {
	    COUNT : "count", //数量，不传，默认为1；不限：传“infinite”
	    SIZE : "size", //单个文件大小
	    TOTAL_SIZE : "totalSize" //大小（总大小）
	};
})();
/**
 * 下载组件
 */
(function(){
	/**
	 * 下载组件调用参数列表
	 */
	app.downloadType = {
		TO_BE_OPEN : "toBeOpen",
		ONLY_DOWNLOAD : "onlyDownload"
	};
	app.downloadParams = {
		downType:app.downloadType.TO_BE_OPEN,//仔仔模式下载后打开，还是只下载提醒
		fileExt:"",//文件后缀名
		fileName:"",//文件名称
		downUrl:"",//下载接口请求完整地址
		downloadParams: {},//下载带参，必须json格式
		jsCallback:"",//下载过程中回调，提供下载速度、已下载大小、下载总大小等
        callbackParams:{},//下载过程中回调参数，
        uniqueKey:""//唯一标识
	};
	/**
	 * 下载组件callback回参增加
	 */
	app.downloadCallbackParams = {
		speed:"0KB/s",//下载速度
		downloadSize:"",//已下载大小单位是B
		totalSize:"",//需下载总大小单位是B
		status:5//prepare = 1;ready = 2;waiting = 3;start = 4;downloading = 5;pause = 6;resume = 7;cancel = 8;fail = 9;success = 10;joinFailed = 11;joinSuc = 12;
	}
})();
/**
 * 上传组件
 */
(function(){
	/**
	 * 上传组件调用参数列表
	 */
	app.uploadParams = {
		zip:false,//ture表示打压缩包，false表示不打压缩包；默认使用false;
		breakpoint:false,//ture表示断点续传，false表示不支持断点续传；默认使用false;
		filePaths:[],//本地文件完整路径，
        uploadParams: [{}],//上传带参，必须json格式,并且会带回到callbackParams中的uploadParams属性中
        fileParamsKey: "",//上传接口中文件的对应request的key
        uploadUrl:"",//上传接口请求完整地址
        callbackParams:{},//上传过程中回调参数，
        callback:"",//上传过程中回调，提供上传速度、已上传大小、上传总大小等
        listSearchKey:""//查询列表key
	};
	/**
	 * 上传组件callback回参增加
	 */
	app.uploadCallbackParams = {
		type:"",//file,task
		taskId:"",//扩展停止等
		speed:"0KB/s",//上传速度
		uploadedSize:"",//已上传大小单位是B
		totalSize:"",//需上传总大小单位是B
		status:5,//prepare = 1;ready = 2;waiting = 3;start = 4;uploading = 5;pause = 6;resume = 7;cancel = 8;fail = 9;success = 10;joinFailed = 11;joinSuc = 12;
		uploadParams:"json",//上传请求带参
		response:"json"//上传返回json返回信息
	}
})();
/**
 * 二维码扫描组件
 */
(function(){
    /**
     * 二维码扫描组件调用参数列表
     */
    app.qRCodeScanType = {
        SCANTYPE_SINGLE : "scanTypeSingle",//单一扫描
        SCANTYPE_MULTI : "scanTypeMulti"//重复扫描
    };
    app.qRCodeScanResultArray = "qrResultArray";//扫描结果json数组名
    app.qRCodeScanParams = {
        scanType:app.qRCodeScanType.SCANTYPE_SINGLE,//扫描模式，单一扫描还是连续扫描。默认单一扫描
        jsCallback:"app.qRCodeCallBack",//扫描完成后回调，回调参数是扫描结果组装的json字符串
        resultArray:app.qRCodeScanResultArray
    };
})();
/**
 * 多媒体采集组件
 */
(function(){
    /**
     * 二维码扫描组件调用参数列表
     */
    app.collectionType = {
    	DEFAULT : "0",//默认为拍照＋视频
        PICTURE : "1",//单独拍照
        VIDEO : "2"	//单独视频
    };
    app.collectionFileType = {
    		FILE_TYPE_TEXT : "0",
    		FILE_TYPE_PIC : "1",
    		FILE_TYPE_RECORD : "2",
    		FILE_TYPE_VIDEO : "3"
    };
})();
/**
 * 录音组件
 */
(function(){
    /**
     * 录音组件回调参数
     */
    app.audioRecordCallbackParams = {
        status:100,//操作返回状态 OK=100 CANCEL=101 FAIL=102
        result:[{},{},{}] //录音文件路径数组 暂时最多只有一个值。如果未来扩展到录音暂停和继续录制，可能出现多个结果。
    };
    /**
     * 录音组件调用参数
     */
    app.audioRecordParams = {
        jsCallback:function(data) {
            console.log(data);
        },//扫描完成后回调方法，调用时自定义
        jsCallbackParams:JSON.stringify(app.audioRecordCallbackParams)
    };
})();
/**
 * 媒体播放组件
 */
(function(){
    /**
     * 媒体播放组件回调参数
     */
    app.playMediaCallbackParams = {
        status:100,//操作返回状态 OK=100 CANCEL=101 FAIL=102
        message:""
    };
    /**
     * 文件类型参数
     */
    app.mediaFileType = {
        FILE_TYPE_AUDIO : "file_type_audio",//音频文件
        FILE_TYPE_VIDEO : "file_type_video"//视频文件
    };
    /**
     * 文件来源参数
     */
    app.mediaSourceType = {
        SOURCE_TYPE_LOCAL : 0,//本地文件
        SOURCE_TYPE_AFD : 1,
        SOURCE_TYPE_ONLINE : 2//在线文件
    };
    /**
     * 媒体播放组件调用参数
     */
    app.playMediaParams = {
        jsCallback:function(data) {
            console.log(data);
        },//扫描完成后回调方法，调用时自定义
        jsCallbackParams:JSON.stringify(app.playMediaCallbackParams),
        fileType:app.mediaFileType.FILE_TYPE_AUDIO,
        fileSourceType:app.mediaSourceType.SOURCE_TYPE_ONLINE,
        filePath:"" ,//url或者本地路径
        fileName:""
    };
})();
/**
 * 系统相关回调JS
 */
(function(){
	/**
	 * 拍照的回调需要实现
	 */
	app.shootCallback = function(path){
		console.log("拍照回调未实现");
	};
	app.qRCodeCallBack = function(qrcode){
		console.log("扫描二维码回调未实现");
	};
	app.cropImageCallback = function(){
        console.log("剪裁回调未实现");
    };
})();
/**
 * 前端行为搜集组件
 */
(function(){
	app.recordActionType = {
			PAGE_IN: 0,		//页面进入
	        PAGE_OUT : 1,	//页面跳出
	        PAGE_CLICK:2	//页面点击
	    };
    app.recordCustomInfoParams = {
            projectName: '', //项目名称
            code : 0, //记录类型，可由开发人员自行定义，默认为0
            url: '',//当前记录的页面url地址
            dataMessage:{}	//实际要记录的数据，JSON格式
        };
})();