/**
 * 原生JS的增强性API扩展
 */
define([] ,function(){
	// Array Remove - By John Resig (MIT Licensed)
	Array.prototype.remove = function(from, to) {
	  var rest = this.slice((to || from) + 1 || this.length);
	  this.length = from < 0 ? this.length + from : from;
	  return this.push.apply(this, rest);
	};
	/**
	 * Array.prototype.[method name] allows you to define/overwrite an objects method
	 * needle is the item you are searching for
	 * this is a special variable that refers to "this" instance of an Array.
	 * returns true if needle is in the array, and false otherwise
	 */
	Array.prototype.contains = function ( needle ) {
	  for (i in this) {
	    if (this[i] == needle) return true;
	  }
	  return false;
	};
	Array.prototype.indexOf = function(val) {
		for (var i = 0; i < this.length; i++) {
			if (this[i] == val) return i;
		}
		return -1;
	};
	/*
    for (i in obj) {
        if (callback.call(obj[i], i, obj[i]) === false) {
            break;
        }
    }
	*/
    Array.prototype.each = function(callback){
        var length = this.length, i = 0;
        for (; i < length; i++) {
            if (callback.call(obj[i], i, obj[i]) === false) {
                break;
            }
        }
    };
	/**去掉前后空格*/
    String.prototype.trim = function(){
        return this.replace(/^\s+|\s+$/g,'');
    };
    /**替换*/
    String.prototype.replaceAll = function(from,to) {
        while(source.indexOf(from)>=0) {
            source = source.replace(from,to);
        }
        return source;
    }
    String.prototype.endWith=function(str){
        if(str==null||str==""||this.length==0||str.length>this.length)
            return false;
        if(this.substring(this.length-str.length)==str)
            return true;
        else
            return false;
     }
     String.prototype.startWith=function(str){
        if(str==null||str==""||this.length==0||str.length>this.length)
            return false;
        if(this.substr(0,str.length)==str)
            return true;
        else
            return false;
     }
    return {
        version:app.version,//"2.0.0",
        content:"Array增强remove、contains、indexOf、each；String增强trim、replaceAll、startWith、endWith、",
    };
});