"use strict";
define(["happ-mobile"] ,function(mobile){

    var shareInit = function(){
        mobile.shareSocializationApp = shareSocializationApp;
        mobile.shareVersion = app.version;//版本
        return mobile;
    }

    var shareSocializationApp = function(jsonParams){
        var shareTitle = jsonParams.title;
        if (!shareTitle) {
            shareTitle = "";
        }
        if (shareTitle.length > 50) {
            var shareTitleTemp = shareTitle.substring(0, 50);
            shareTitle = shareTitleTemp + "...";
        }
        var shareContent = jsonParams.content;
        if (!shareContent) {
            shareContent = "";
        }
        shareContent = shareContent.replace(/<\/?.+?>/g,"");
        if (shareContent.length > 100) {
            var shareContentTemp = shareContent.substring(0, 100);
            shareContent = shareContentTemp + "...";
        }
        jsonParams["title"] = shareTitle;
        jsonParams["content"] = shareContent;
        var stringJsonParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getShareApi(),'shareSocializationApp',stringJsonParams);
    }

    var getShareApi = function(){
        return window.ShareApp?window.ShareApp:"ShareApp";
        try {
           return ShareApp;
        }catch(err){
        //ios return 一个未定义的 变量会报错，停止执行
           return "ShareApp";
        }
    }

    return shareInit();
});
