"use strict";
define([""] ,function(){
    function initBridge(callBack) {
        if (window.TYHAPPBridge) { return callback(TYHAPPBridge); }
        if (window.TYHAPPBridgeCallBack) { return window.TYHAPPBridgeCallBack.push(callback); }
        window.TYHAPPBridgeCallBack = [callBack];
        var BridgeFrame = document.createElement('iframe');
        BridgeFrame.style.display = 'none';
        BridgeFrame.src = 'https://__bridge_loaded__';
        document.documentElement.appendChild(BridgeFrame);
        setTimeout(function() { document.documentElement.removeChild(BridgeFrame) }, 0)
    }
    function addHistoryBackListener(){
        TYHAPPBridge.registerHandler("historyBack",function(){
            nativeDoHistoryBack();
        });
    }
    function bridgeIOC(bridge, functionName, param) {
        TYHAPPBridge.callHandler(functionName, param, function(response){});
    }
    return {
        version: app.version,
        initBridge : initBridge,
        bridgeIOC: bridgeIOC
    };
});
