
"use strict";
define(["happ-mobile","happjs","request"] ,function(mobile,happjs){
    var uiInit = function(){
        mobile.app = app;                                                   //来自于mobile-require-min-v2.1.11.js定义的全局变量；唯一的自定义全局变量；
        mobile.init = init;                                                 //初始化入口
        mobile.getJsCallJava = getJsCallJava;                               //得到js调android原生切口对象
        mobile.openDownloadLine = openDownloadLine;                         //js调用android原生开启下载文件并打开
//主动缓存组件
        mobile.cacheFiles = cacheFiles;                                     //js调用android原生下载任务集合
        mobile.cacheUpdate = cacheUpdate;
        mobile.cacheUpdateIncremental = cacheUpdateIncremental;             //macheng？这是什么
        mobile.cacheRemove = cacheRemove;
        mobile.cacheResume = cacheResume;
        mobile.cachePause = cachePause;
        mobile.cacheCancel = cacheCancel;
        mobile.cacheUrl = cacheUrl;
        mobile.getAllCacheTask = getAllCacheTask;
//门户SSO token
        mobile.generateAccessCode = generateAccessCode;
//websocket组件
        mobile.onWebSocketOpen = onWebSocketOpen;
        mobile.onWebSocketClosed = onWebSocketClosed;
        mobile.onWebSocketError = onWebSocketError;
        mobile.onWebSocketMessage = onWebSocketMessage;
        mobile.onWebSocketClosing = onWebSocketClosing;
        mobile.connectWebSocket = connectWebSocket;
        mobile.closeWebSocket = closeWebSocket;
        mobile.sendMessage = sendMessage;

        mobile.nativeDoChooseFile = nativeDoChooseFile;                     //js调用android原生选择文件
        mobile.showNativeToast = showNativeToast;                           //js调原生Toast
        mobile.nativeDoBrowserFinish = nativeDoBrowserFinish;               //js调用android原生关闭当前浏览器
        mobile.nativeCollectMultimedia = nativeCollectMultimedia;           //调用原生的多媒体采集组件
        mobile.nativeDoUpload = nativeDoUpload;                             //js调用android原生上传组件
        mobile.setCookieForNative = setCookieForNative;                     //js调原生设置Cookie
        mobile.clearAllCookie = clearAllCookie;
        mobile.nativeDoOpenFile = nativeDoOpenFile;                         //js调用android原生打开文件
        mobile.shootPicture = shootPicture;                                 //js调用android原生的拍照，只有拍照
        mobile.nativeDoHistoryBack = nativeDoHistoryBack;                   //js调用android原生的返回操作
        mobile.nativeDoPhotoSlider = nativeDoPhotoSlider;                   //js调用android原生打开图片浏览器
        mobile.openNativeActivity = openNativeActivity;                     //js调用android原生的打开相应activity
        mobile.getNativeActivityParams = getNativeActivityParams;           //获取 js调用打开原生activity的参数
        mobile.registCacheFilesListener = registCacheFilesListener;

        mobile.showConfirm = showConfirm;                                   //弹出系统提示框confirm
        mobile.showAlert = showAlert;                                       //弹出系统提示框alert

        mobile.registNativeDoEventReceiver = registNativeDoEventReceiver;   //不暴露,js注册原生事件（支持返回、等）广播

        mobile.settingSetShow = settingSetShow;                             //设置右上角setting显隐
        mobile.settingSetText = settingSetText;                             //设置右上角setting的text
        mobile.settingSetBG = settingSetBG;                                 //设置右上角setting的背景图片，可系统可图片地址
        mobile.titleSetShow = titleSetShow;                                 //设置title的显隐
        mobile.titleSetText = titleSetText;                                 //设置title的文字
        mobile.homeSetText = homeSetText;                                   //设置 返回 文字
        mobile.homeSetIcon = homeSetIcon;                                   //设置返回图标
        mobile.homeSetLogo = homeSetLogo;                                   //设置logo图标
        mobile.playAudio = playAudio;

        mobile.setDate = setDate;                                           //js调原生 设置本地维护时间
        mobile.getDate = getDate;                                           //js调原生 获取本地维护时间
        mobile.setProjectName = setProjectName;                             //js调原生 设置当前activity的projectName
        mobile.recordCustomInfo = recordCustomInfo;                         //js调原生 项目自定义数据搜集组件

        mobile.forceUpdate = forceUpdate;                                   //强制检测版本更新，并且即使用户忽略了该版本也会弹出对话框提示更新。
        mobile.thunisoftBlockUI = thunisoftBlockUI;                         //展示华宇logo 加载中
        mobile.thunisoftUnblockUI = thunisoftUnblockUI;                     //取消华宇logo 加载中

        mobile.getVersionName = getVersionName;                             //获取app版本

        mobile.nativeDoFileExist = nativeDoFileExist;                       //js调用android原生判断文件存在
        mobile.nativeDoMemcache = nativeDoMemcache;                         //js调用android原生开启memcache缓存，内存中随应用关闭而消失
        mobile.nativeDoLoadMemcache = nativeDoLoadMemcache;                 //js调用android原生加载memcache缓存，内存中随应用关闭而消失
        mobile.memcacheDirectGet = memcacheDirectGet;                       //js调用android原生加载memcache缓存，内存中随应用关闭而消失
        mobile.diskcacheDirectGet = diskcacheDirectGet;                     //js调用android原生加载diskcache缓存，固态应用卸而消失
        mobile.nativeDoLoadDiskcache = nativeDoLoadDiskcache;               //js调用android原生加载diskcache缓存，固态应用卸而消失
        mobile.nativeDoDiskcache = nativeDoDiskcache;                       //js调用android原生开启diskcache缓存，固态应用卸而消失
        mobile.nativeDoWVScreenShot = nativeDoWVScreenShot;                 //js调用android原生webview截屏
        mobile.playMedia = playMedia;                                       //js调用android原生播放媒体文件
        mobile.startAudioRecord = startAudioRecord;                         //js调用android原生开始录音
        mobile.stopAudioRecord = stopAudioRecord;                           //js调用android原生停止录音
        mobile.qRCodeCapture = qRCodeCapture;                               //js调原生扫描二维码
        mobile.qRCodeScan = qRCodeScan;                                     //js调用android原生扫描二维码新方法
        mobile.nativeDoEncryption = nativeDoEncryption;                     //js调用android原生的加密，建议使用只支持Base64，并且utf-8字符集
        mobile.nativeDoDecryption = nativeDoDecryption;                     //js调用android原生的解密，建议使用只支持Base64，并且utf-8字符集
        mobile.delCdrCacheDir = delCdrCacheDir;                             //js调用android原生删除CDR缓存整个文件夹

        mobile.getRouterParam = getRouterParam;                             //获取router参数
        mobile.getRouterParams = getRouterParams;                           //router跳转后获取跳转参数

        mobile.randomUniqueString = happjs.randomUniqueString;

        return mobile;
    }
    var didLoad = false;
    function init(){ //需要重新设计，此函数存在线程不安全问题，可能会导致函数体多次创建，被替换
        //修改为幂等性处理 @zhaozhiyu 2017-09-29
        if(!didLoad){
            didLoad = true;
            var isInit = mobile.initBridge?mobile.initBridge():false;//存在即执行；
            initPushState();
            initEventListener();
        }
    }
    /**
     * 原生showToast
     */
    function showNativeToast(toast, duration){
        if(!duration){
            duration = 'short';//'long'
        }
        var params = {
            'message':toast,
            'duration':duration
            };
        mobile.bridgeIOC(getJsCallJava(),"showNativeToast",JSON.stringify(params));
    }
    /**
     * 给原生复制 session cookie
     */
    function setCookieForNative(url){
        mobile.bridgeIOC(getJsCallJava(),"setCookieForNative",url);
    }
    /**
     * 删除CDR缓存整个文件夹
     */
    function delCdrCacheDir(jsonParams){
        if(!jsonParams){
            mobile.log.error("delCdrCacheDir的参数不能为空");
        }
        if(!jsonParams.jsCallback){
            jsonParams.jsCallback = '';
        }else{
            jsonParams.jsCallback = happjs.generateJsCallbackStr(jsonParams.jsCallback);
        }
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"nativeDoDelCdrCacheDir",jsonStringParams);
    }

    function clearAllCookie(){
        mobile.bridgeIOC(getJsCallJava(),"clearAllCookie");
    }

    /**
     * 扫描二维码
     */
    function qRCodeCapture(jsCallback){
        if(!jsCallback){
            console.log("qRCodeCapture的参数不能为非");
        }
        mobile.bridgeIOC(getJsCallJava(),"qRCodeCapture",happjs.generateJsCallbackStr(jsCallback));
    }
    /**
     * 扫描二维码新方法，支持重复扫描
     * jsonParams参数参见mobile-require-min的js文件app.qRCodeScanParams
     */
    function qRCodeScan(jsonParams){
        if(!jsonParams){
            mobile.log.error("qRCodeScan的参数不能为非");
        }
        if (!jsonParams.scanType){
            jsonParams.scanType = app.qRCodeScanType.SCANTYPE_SINGLE;
        }
        if(!jsonParams.resultArray){
            jsonParams.resultArray = app.qRCodeScanResultArray;
        }
        if(!jsonParams.jsCallback){
            jsonParams.jsCallback = '';
        }else{
            jsonParams.jsCallback = happjs.generateJsCallbackStr(jsonParams.jsCallback);
        }
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"qRCodeScan",jsonStringParams);
    }
    /**
     * 录音组件：开始录音
     * jsonParams参数参见mobile-require-min的js文件app.audioRecordParams
     */
    function startAudioRecord(jsonParams){
        if(!jsonParams){
            mobile.log.error("startAudioRecord的参数不能为非");
        }
        if(!jsonParams.jsCallbackParams){
            jsonParams.jsCallbackParams = JSON.stringify(app.audioRecordCallbackParams);
        }
        if(!jsonParams.jsCallback){
            jsonParams.jsCallback = '';
        }else{
            jsonParams.jsCallback = happjs.generateJsCallbackStr(jsonParams.jsCallback);
        }
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"startAudioRecord",jsonStringParams);
    }
    /**
     * 录音组件：停止录音
     */
    function stopAudioRecord(jsonParams){
        if(!jsonParams){
            mobile.log.error("stopAudioRecord的参数不能为非");
        }
        if(!jsonParams.jsCallbackParams){
            jsonParams.jsCallbackParams = JSON.stringify(app.audioRecordCallbackParams);
        }
        if(!jsonParams.jsCallback){
            jsonParams.jsCallback = '';
        }else{
            jsonParams.jsCallback = happjs.generateJsCallbackStr(jsonParams.jsCallback);
        }
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"stopAudioRecord",jsonStringParams);
    }
    /**
     * 媒体播放组件
     * jsonParams参数参见mobile-require-min的js文件app.playMediaParams
     */
    function playMedia(jsonParams){
        if(!jsonParams){
            mobile.log.error("playMedia的参数不能为非");
        }
        if(!jsonParams.jsCallbackParams){
            jsonParams.jsCallbackParams = JSON.stringify(app.playMediaCallbackParams);
        }
        if(!jsonParams.fileType) {
            jsonParams.fileType = app.mediaFileType.FILE_TYPE_VIDEO;
        }
        if(!jsonParams.fileSourceType) {
            jsonParams.fileSourceType = app.mediaSourceType.SOURCE_TYPE_LOCAL;
        }
        if(!jsonParams.jsCallback){
            jsonParams.jsCallback = '';
        }else{
            jsonParams.jsCallback = happjs.generateJsCallbackStr(jsonParams.jsCallback);
        }
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"playMedia",jsonStringParams);
    }
    /**
     * 原生实现返回
     */
    function nativeDoHistoryBack(go){
        go = go==undefined ? -1 : go;
        mobile.bridgeIOC(getJsCallJava(),"historyBack",go);
    }
    /**
     * decryption
     */
    function nativeDoEncryption(encodeCode, encodeString, jsCallback){
        setTimeout(function(){
            var params = {
                'encodeCode':encodeCode,
                'encodeString':encodeString,
                'jsCallback':happjs.generateJsCallbackStr(jsCallback)
            };
            mobile.bridgeIOC(getJsCallJava(),"encryption",JSON.stringify(params));
        },500);
    }
    /**
     * decryption
     */
    function nativeDoDecryption(decodeCode, decodeString, jsCallback){
        setTimeout(function(){
            var params = {
                'decodeCode':decodeCode,
                'decodeString':decodeString,
                'jsCallback':happjs.generateJsCallbackStr(jsCallback)
            };
            mobile.bridgeIOC(getJsCallJava(),"decryption",JSON.stringify(params));
        },500);
    }
    /**
     * 打开原生Activity
     * json
     * target: _self(继续本页打开)、_blank(关闭自己，打开新页)
     */
    function openNativeActivity(nativeActivity, jsonParams, target){
        var stringParams = '';
        if(jsonParams){
            stringParams = JSON.stringify(jsonParams);
        }
        if(!target){
            target="_self";
        }
        putNativeActivityParams(jsonParams);
        var params = {
            'activity':nativeActivity,
            'params':stringParams,
            'target':target
        };
        mobile.bridgeIOC(getJsCallJava(),"openNativeActivity",JSON.stringify(params));
    }

    /**
     * 封装打开activity参数到sessionStorage
     * json
     */
    function putNativeActivityParams(jsonParams){
        var sessionStorage = window.localStorage;
        var bankruptManagerStr = sessionStorage.getItem("bankrupt_manager");
        var bankruptManager = {};
        if (null != bankruptManagerStr && "" != bankruptManagerStr) {
            bankruptManager = JSON.parse(bankruptManagerStr);
        }
        bankruptManager["params"] = jsonParams;
        sessionStorage.setItem("bankrupt_manager", JSON.stringify(bankruptManager));
    }

    /**
     * 获取上一个页面传进来的参数
     * json
     */
    function getNativeActivityParams(){
        var sessionStorage = window.localStorage;
        var bankruptManagerStr = sessionStorage.getItem("bankrupt_manager");
        var bankruptManager = JSON.parse(bankruptManagerStr);
        return bankruptManager["params"];
    }

    /**
     * 获取router传进来的参数
     * json
     */
    function getRouterParams(){
        return getNativeActivityParams();
    }

    /**
     * 原生开启memcache缓存
     */
    function nativeDoMemcache(key, value){
        var params = {
            'key':key,
            'value':value
        };
        mobile.bridgeIOC(getJsCallJava(),"memcachePut",JSON.stringify(params));
    }
    /**
     * 原生加载memcache缓存
     */
    function nativeDoLoadMemcache(key, jsCallback){
        var params = {
            'key':key,
            'jsCallback':happjs.generateJsCallbackStr(jsCallback)
        };
        mobile.bridgeIOC(getJsCallJava(),"memcacheGet",JSON.stringify(params));
    }
    /**
     * 原生加载memcache缓存
     */
    function memcacheDirectGet(key){
        return mobile.bridgeIOC(getJsCallJava(),"memcacheDirectGet",key);
    }

    function cacheUrl(key,value,jsCallback){
            if(!key){
                return false;
            }
            if(!value){
                return false;
            }
            var params = {
                'key':key,
                'value':value
            };
            if(!jsCallback){
                jsCallback = '';
            }else{
                jsCallback = happjs.generateJsCallbackStr(jsCallback);
            }
            params.htmlCallback = jsCallback;
            mobile.bridgeIOC(getJsCallJava(),"cacheUrl",JSON.stringify(params));
        }
    /**
     * 原生开启memcache缓存
     */
    function nativeDoDiskcache(key, value){
        var params = {
            'key':key,
            'value':value
        };
        mobile.bridgeIOC(getJsCallJava(),"diskcachePut",JSON.stringify(params));
    }
    /**
     * 原生加载memcache缓存
     */
    function nativeDoLoadDiskcache(key, jsCallback){
        var params = {
            'key':key,
            'jsCallback':happjs.generateJsCallbackStr(jsCallback)
        };
        mobile.bridgeIOC(getJsCallJava(),"diskcacheGet",JSON.stringify(params));
    }
    /**
     * 原生加载memcache缓存
     */
    function diskcacheDirectGet(key){
        return mobile.bridgeIOC(getJsCallJava(),"diskcacheDirectGet",key);
    }
    /**
     * 原生上传组件，uploadParams参数参见mobile-require-min的js文件app.uploadParams
     */
    function nativeDoUpload(uploadParams){
        var stringParams = '';
        if(!uploadParams){
            return false;
        }
        if(uploadParams.zip == undefined){
            uploadParams.zip = false;
        }
        if(uploadParams.breakpoint == undefined){
            uploadParams.breakpoint = false;
        }
        if(!uploadParams.filePaths || !(uploadParams.filePaths.length)){
            return false;
        }
        if(!uploadParams.uploadParams){
            uploadParams.uploadParams = [];
        }
        if(!uploadParams.fileParamsKey){
            return false;
        }
        if(!uploadParams.uploadUrl){
            return false;
        }
        if(!uploadParams.callbackParams){
            uploadParams.callbackParams = {};
        }
        if(!uploadParams.callback){
            return false;
        }else{
            uploadParams.callback = happjs.generateJsCallbackStr(uploadParams.callback);
        }
        if(!uploadParams.listSearchKey || uploadParams.listSearchKey == ""){
            uploadParams.listSearchKey = "nolist";
        }
        stringParams = JSON.stringify(uploadParams);
        mobile.bridgeIOC(getJsCallJava(),"nativeDoUpload",stringParams);
        return true;
    }
    /**
     * 截屏
     */
    function nativeDoWVScreenShot(filename, jsCallback){
        var params = {
            'fileName':filename,
            'jsCallback':happjs.generateJsCallbackStr(jsCallback)
        };
        mobile.bridgeIOC(getJsCallJava(),"nativeDoWebViewScreenShot",JSON.stringify(params));
    }
    /**
     * 关闭当前浏览器tab
     */
    function nativeDoBrowserFinish(){
        mobile.bridgeIOC(getJsCallJava(),"nativeDoBrowserFinish");
    }
    /**
     * 文件存在
     * fileType:app.fileExistType.ANY,//仔仔模式下载后打开，还是只下载提醒
        uniqueKey:""//唯一标识
        fileExt:"",//文件后缀名
        fileName:"",//文件名称
        jsCallback:"",//下载过程中回调，提供下载速度、已下载大小、下载总大小等
        callbackParams:{},//下载过程中回调参数，
     */
    function nativeDoFileExist(jsonParams){
        var stringParams = '';
        if(!jsonParams){
            return false;
        }
        if(!jsonParams.fileType){
            jsonParams.fileType = app.fileExistType.ANY;
        }
        if(jsonParams.fileType == app.fileExistType.DOWNLOAD){
            if(!jsonParams.uniqueKey){
                return false;
            }
            if(!jsonParams.fileExt){
                return false;
            }
        }
        if(!jsonParams.fileName){
            return false;
        }
        if(!jsonParams.jsCallback){
            return false;
        }else{
            jsonParams.jsCallback = happjs.generateJsCallbackStr(jsonParams.jsCallback);
        }
        if(!jsonParams.callbackParams){
            jsonParams.callbackParams = {};
        }
        stringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"nativeDoFileExist",stringParams);
    }
    /**
     * 打开文件
     */
    function nativeDoOpenFile(jsonParams){
        var stringParams = '';
        if(!jsonParams){
            return false;
        }
        if(!jsonParams.fileType){
            jsonParams.fileType = app.fileOpenType.ANY;
        }
        if(jsonParams.fileType == app.fileOpenType.DOWNLOAD){
            if(!jsonParams.uniqueKey){
                return false;
            }
            if(!jsonParams.fileExt){
                return false;
            }
        }
        if(!jsonParams.fileName){
            return false;
        }
        if(!jsonParams.jsCallback){
            jsonParams.jsCallback = '';
        }else{
            jsonParams.jsCallback = happjs.generateJsCallbackStr(jsonParams.jsCallback);
        }
        stringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"nativeDoOpenFile",stringParams);
    }
    /**
     * 图片浏览器
     */
    function nativeDoPhotoSlider(jsonParams){
        var stringParams = '';
        stringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"nativeDoPhotoSlider",stringParams);
    }
    /**
     * 拍照
     */
    function shootPicture(fileIdSelector, showIdSelector, callback){
        mobile.bridgeIOC(getJsCallJava(),"shootPicture");
    }
    /**
     * 启动下载器，开启下载任务
     */
    function openDownloadLine(jsonParams){
        if(!jsonParams.downType){
            jsonParams.downType = app.downloadType.TO_BE_OPEN;
        }
        if(!jsonParams.fileExt){
            return false;
        }
        if(!jsonParams.fileName){
            return false;
        }
        if(!jsonParams.downUrl){
            showNativeToast('文件下载地址不存在');
            return false;
        }
        if(!jsonParams.downloadParams){
            jsonParams.downloadParams = {};
        }
        if(!jsonParams.jsCallback){
            jsonParams.jsCallback = '';
        }else{
            jsonParams.jsCallback = happjs.generateJsCallbackStr(jsonParams.jsCallback);
        }
        if(!jsonParams.callbackParams){
            jsonParams.callbackParams = {};
        }
        if(!jsonParams.uniqueKey){
            jsonParams.uniqueKey = '';
        }
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"openDownloadLine",jsonStringParams);
        return true;
    }


    /**
     * 启动下载任务集
     */
    function cacheFiles(jsonParams,jsCallback){
        if(!jsonParams.appId){
            return false;
        }
        if(!jsonParams.primaryId){
            return false;
        }
        if(!jsonParams.dataInfo){
            return false;
        }
        if(!jsonParams.fileInfo){
            return false;
        }
        if(!jsonParams.totalLength){
            return false;
        }
        if(!jsonParams.jsCallback){
            jsonParams.jsCallback = '';
        }else{
            jsonParams.jsCallback = happjs.generateJsCallbackStr(jsonParams.jsCallback);
        }
        if(!jsCallback){
            jsCallback = '';
        }else{
            jsCallback = happjs.generateJsCallbackStr(jsCallback);
        }
        jsonParams.htmlCallback = jsCallback;
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"cacheFiles",jsonStringParams);
        return true;
    }

    function cacheUpdate(jsonParams,jsCallback){
        if(!jsonParams.appId){
            return false;
        }
        if(!jsonParams.primaryId){
            return false;
        }
        if(!jsonParams.dataInfo){
            return false;
        }
        if(!jsonParams.fileInfo){
            return false;
        }
        if(!jsonParams.totalLength){
            return false;
        }
        if(!jsonParams.jsCallback){
          jsonParams.jsCallback = '';
        }else{
          jsonParams.jsCallback = happjs.generateJsCallbackStr(jsonParams.jsCallback);
        }
        if(!jsCallback){
          jsCallback = '';
        }else{
          jsCallback = happjs.generateJsCallbackStr(jsCallback);
        }
        jsonParams.htmlCallback = jsCallback;
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"cacheUpdate",jsonStringParams);
        return true;
    }
     function cacheUpdateIncremental(jsonParams,jsCallback){
            if(!jsonParams.appId){
                return false;
            }
            if(!jsonParams.primaryId){
                return false;
            }
            if(!jsonParams.dataInfo){
                return false;
            }
            if(!jsonParams.fileInfo){
                return false;
            }
            if(!jsonParams.totalLength){
                return false;
            }
            if(!jsonParams.jsCallback){
              jsonParams.jsCallback = '';
            }else{
              jsonParams.jsCallback = happjs.generateJsCallbackStr(jsonParams.jsCallback);
            }
            if(!jsCallback){
              jsCallback = '';
            }else{
              jsCallback = happjs.generateJsCallbackStr(jsCallback);
            }
            jsonParams.htmlCallback = jsCallback;
            var jsonStringParams = JSON.stringify(jsonParams);
            mobile.bridgeIOC(getJsCallJava(),"cacheUpdateIncremental",jsonStringParams);
            return true;
        }

    function cacheCancel(jsonParams,jsCallback){
        if(!jsonParams.appId){
            return false;
        }
        if(!jsonParams.primaryId){
            return false;
        }
        if(!jsCallback){
            jsCallback = '';
        }else{
            jsCallback = happjs.generateJsCallbackStr(jsCallback);
        }
        jsonParams.htmlCallback = jsCallback;
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"cacheCancel",jsonStringParams);
        return true;
    }

    function cacheRemove(jsonParams,jsCallback){
        if(!jsonParams.appId){
            return false;
        }
        if(!jsCallback){
          jsCallback = '';
        }else{
          jsCallback = happjs.generateJsCallbackStr(jsCallback);
        }
        jsonParams.htmlCallback = jsCallback;
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"cacheRemove",jsonStringParams);
        return true;
    }

    function cachePause(jsonParams,jsCallback){
        if(!jsonParams.appId){
            return false;
        }
        if(!jsonParams.primaryId){
            return false;
        }
        if(!jsCallback){
            jsCallback = '';
        }else{
            jsCallback = happjs.generateJsCallbackStr(jsCallback);
        }
        jsonParams.htmlCallback = jsCallback;
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"cachePause",jsonStringParams);
        return true;
    }

    function cacheResume(jsonParams,jsCallback){
        if(!jsonParams.appId){
            return false;
        }
        if(!jsonParams.primaryId){
            return false;
        }
        if(!jsCallback){
            jsCallback = '';
        }else{
            jsCallback = happjs.generateJsCallbackStr(jsCallback);
        }
        jsonParams.htmlCallback = jsCallback;
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"cacheResume",jsonStringParams);
        return true;
    }

    function getAllCacheTask(jsonParams,jsCallback){
        if(!jsonParams.appId){
            return false;
        }
        if(!jsCallback){
          jsCallback = '';
        }else{
          jsCallback = happjs.generateJsCallbackStr(jsCallback);
        }
        jsonParams.htmlCallback = jsCallback;
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"getAllCacheTask",jsonStringParams);
        return true;
    }

    function registCacheFilesListener(jsonParams,jsCallback){
        if(!jsonParams){
            return false;
        }
        if(!jsonParams.appId){
            return false;
        }
        if(!jsonParams.primaryId){
            return false;
        }
        if(!jsonParams.jsCallback){
            return false;
        }
        jsonParams.jsCallback = happjs.generateJsCallbackStr(jsonParams.jsCallback);
        if(!jsCallback){
            jsCallback = '';
        }else{
            jsCallback = happjs.generateJsCallbackStr(jsCallback);
        }
        jsonParams.htmlCallback = jsCallback;
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"registDownloadFilesListener",jsonStringParams);
        return true;
    }

    function generateAccessCode(jsonParams){
        if(!jsonParams){
            return false;
        }
        if(!jsonParams.appId){
            return false;
        }
        if(!jsonParams.callback){
            return false;
        }
        jsonParams.jsCallback = happjs.generateJsCallbackStr(jsonParams.callback);
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"generateAccessCode",jsonStringParams);
    }

    function onWebSocketOpen(jsCallback){
        if(!jsCallback){return false;}
        jsCallback = happjs.generateJsCallbackStr(jsCallback);
        mobile.bridgeIOC(getJsCallJava(),"onWebSocketOpen",jsCallback);
    }
    function onWebSocketClosed(jsCallback){
        if(!jsCallback){return false;}
        jsCallback = happjs.generateJsCallbackStr(jsCallback);
        mobile.bridgeIOC(getJsCallJava(),"onWebSocketClosed",jsCallback);
    }
    function onWebSocketError(jsCallback){
        if(!jsCallback){return false;}
        jsCallback = happjs.generateJsCallbackStr(jsCallback);
        mobile.bridgeIOC(getJsCallJava(),"onWebSocketError",jsCallback);
    }
    function onWebSocketMessage(jsCallback){
        if(!jsCallback){return false;}
        jsCallback = happjs.generateJsCallbackStr(jsCallback);
        mobile.bridgeIOC(getJsCallJava(),"onWebSocketMessage",jsCallback);
    }
    function onWebSocketClosing(jsCallback){
        if(!jsCallback){return false;}
        jsCallback = happjs.generateJsCallbackStr(jsCallback);
        mobile.bridgeIOC(getJsCallJava(),"onWebSocketClosing",jsCallback);
    }
    function connectWebSocket(jsonParams){
        if(!jsonParams.url){return false;}
        //var jsCallback = happjs.generateJsCallbackStr(jsonParams.callback)
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"connectWebSocket",jsonStringParams);
    }
    function closeWebSocket(){
        mobile.bridgeIOC(getJsCallJava(),"closeWebSocket");
    }
    function sendMessage(text){
        if(!text){return false;}
        mobile.bridgeIOC(getJsCallJava(),"sendMessage",text);
    }

    /**
     * android系统响应监听事件
     */
    function nativeDoEventListener(eventType){
        mobile.bridgeIOC(getJsCallJava(),"nativeDoEventListener",eventType);
    }

    /**
     * 原生选择图片
     */
    function nativeDoChooseFile(jsonParams){
        var stringJsonParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"nativeDoChooseFile",stringJsonParams);
    }

    /**
     * android系统响应监听事件
     */
    function registNativeDoEventReceiver(jsonParams){
        if(!jsonParams.url){
            jsonParams.url = app.location.href;
        }
        if(jsonParams.type == app.EventListenersType.BackPress){
            if(!jsonParams.url){
                jsonParams.url = app.location.href;
            }
            if(jsonParams.callback){
                app.eventListeners.backPress[jsonParams.url] = jsonParams.callback;
            }else if(jsonParams.positiveButton.click){
                app.eventListeners.backPress[jsonParams.url] = jsonParams.positiveButton.click;
            }else{
                console.log("add时，backPress没有设置有效的回调");
                return;
            }
        }else if(jsonParams.type == app.EventListenersType.SettingPress){
            app.eventListeners.settingPress[jsonParams.url] = jsonParams.callback;
            return;
        }else if(jsonParams.type == app.EventListenersType.HtmlOnResume){//html页面resume
            app.eventListeners.htmlOnResume[jsonParams.url] = jsonParams.callback;
        }else if(jsonParams.type == app.EventListenersType.HtmlOnStop){//html页面stop
            app.eventListeners.htmlOnStop[jsonParams.url] = jsonParams.callback;
        }else if(jsonParams.type == app.EventListenersType.FileChoose){//html页面选择文件
            app.eventListeners.fileChoose[jsonParams.url] = jsonParams.callback;
        }else if(jsonParams.type == app.EventListenersType.VoiceListener){//语音监听
            app.eventListeners.voiceListener[jsonParams.url] = jsonParams.callback;
        }else if(jsonParams.type == app.EventListenersType.CollectListener){//拍照，视频监听
            if(!jsonParams.url){
                jsonParams.url = app.location.href;
            }
            if(jsonParams.callback){
                app.eventListeners.collectListener[jsonParams.url] = jsonParams.callback;
            }else{
                console.log("调用camera组件参数错误");
                return;
            }
        }else if(jsonParams.type == app.EventListenersType.NetworkStatusListener){//html页面resume
            app.eventListeners.networkStatusListener[jsonParams.url] = jsonParams.callback;
        }else{
            console.log("add时，没有" + jsonParams.type + "的监听");
            return;
        }
        var jsonStringParams = JSON.stringify(jsonParams);
        mobile.bridgeIOC(getJsCallJava(),"registNativeDoEventReceiver",jsonStringParams);
    }
    /**
     * 设置右上角setting的text
     */
    function settingSetShow(show){
        mobile.bridgeIOC(getJsCallJava(),"settingSetShow",show);
    }
    /**
     * 设置右上角setting的text
     */
    function settingSetText(text, colorString, size){
        var params = {
            'text':text,
            'color':colorString,
            'size':size
        };
        mobile.bridgeIOC(getJsCallJava(),"settingSetText",JSON.stringify(params));
    }
    /**
     * 设置右上角setting的背景
     */
    function settingSetBG(bgStr){
        mobile.bridgeIOC(getJsCallJava(),"settingSetBG",bgStr);
    }
    /**
     * 设置title的显隐
     */
    function titleSetShow(show){
        var params = {
            visible:show
        };
        mobile.bridgeIOC(getJsCallJava(),"titleSetShow",JSON.stringify(params));
    }
    /**
     * 设置title的文字
     */
    function titleSetText(text, colorString, size){
        var params = {
            'text':text,
            'color':colorString,
            'size':size
        };
        mobile.bridgeIOC(getJsCallJava(),"titleSetText",JSON.stringify(params));
    }
    /**
     * 设置 返回 文字
     */
    function homeSetText(text, colorString, size){
        var params = {
            'text':text,
            'color':colorString,
            'size':size
        };
        mobile.bridgeIOC(getJsCallJava(),"homeSetText",JSON.stringify(params));
    }
    /**
     * 设置返回图标
     */
    function homeSetIcon(show){
        var params = {
            visible : show
        }
        mobile.bridgeIOC(getJsCallJava(),"homeSetIcon",JSON.stringify(params));
    }
    /**
     * 设置logo图标
     */
    function homeSetLogo(show){
        var params = {
                visible : show
        }
        mobile.bridgeIOC(getJsCallJava(),"homeSetLogo",JSON.stringify(params));
    }
    /**
     * 强制检测版本更新，并且即使用户忽略了该版本也会弹出对话框提示更新。
     */
    function forceUpdate(jsCallback){
        mobile.bridgeIOC(getJsCallJava(),"forceUpdate",happjs.generateJsCallbackStr(jsCallback));
    }
    /**
     * 获取app版本号
     */
    function getVersionName(jsCallback){
        mobile.bridgeIOC(getJsCallJava(),"packageInfo",happjs.generateJsCallbackStr(jsCallback));
    }
    /**
     * 语音播放
     *  ！！！！！！！！注意，这个方法现在没有实现，请注意，不能使用
     */
    function playAudio(path,id){
        var params = {
            'path':path,
            'id':id
        };
//        mobile.bridgeIOC(getJsCallJava(),"playAudio",JSON.stringify(params));
    }
    /**
     * 设置当前时间
     */
    function setDate(params,jsCallback){
        if(!params){
            mobile.log.error("setDate参数不能为空");
            return;
        }
        if(!params.date){
            mobile.log.error("setDate的date参数不能为空");
            return;
        }
        var jsonParams = {
            'jsCallback':happjs.generateJsCallbackStr(jsCallback),
            'param':params
        };
        mobile.bridgeIOC(getJsCallJava(),"setDate",JSON.stringify(jsonParams));
    }
    /**
     * 设置当前时间
     */
    function getDate(jsCallback){
        if(!jsCallback){
            mobile.log.error("getDate的callback方法异常");
            return;
        }
        mobile.bridgeIOC(getJsCallJava(),"getDate",happjs.generateJsCallbackStr(jsCallback));
    }
    /**
     * 调用原生的多媒体采集组件
     */
    function nativeCollectMultimedia(params){
        if(!params){
            mobile.log.error("nativeCollectMultimedia的参数不能为空");
            return;
        }
        if(!params.collectionType){
            mobile.log.error("nativeCollectMultimedia方法必须要传采集类型collectionType");
            return;
        }
        mobile.bridgeIOC(getJsCallJava(),"nativeCollectMultimedia",JSON.stringify(params));
    }
    /**
     * 获取router参数
     */
    function getRouterParam(url){
        if(url){
            return dealRouterParam(url);
        }else{
            var currentUrl = window.location.href;
            return dealRouterParam(currentUrl);
        }
    }
    function dealRouterParam(url){
        var routerParam = memcacheDirectGet(url);
        if(routerParam){
            return JSON.parse(routerParam);
        }else{
            return "";
        }
    }
    /**
     * 弹出系统提示框confirm
     */
    function showConfirm(args,sureCallback,cancelCallback){
        var params = {
            'param':args,
            'sureCallback':happjs.generateJsCallbackStr(sureCallback),
            'cancelCallback':happjs.generateJsCallbackStr(cancelCallback)
        };
        mobile.bridgeIOC(getJsCallJava(),"showConfirm",JSON.stringify(params));
    }
    /**
     * 弹出系统提示框alert
     */
    function showAlert(args,sureCallback){
        var params = {
            'param':args,
            'sureCallback':happjs.generateJsCallbackStr(sureCallback)
        };
        mobile.bridgeIOC(getJsCallJava(),"showAlert",JSON.stringify(params));
    }
    /**
     * 展示华宇logo 加载中
     */
    function thunisoftBlockUI(fullscreen,cancelable){
        var params = {
            fullscreen:fullscreen?((typeof fullscreen) == 'boolean'?fullscreen:false):false,
            cancelable:cancelable?((typeof cancelable) == 'boolean'?cancelable:true):true,
        };
        mobile.bridgeIOC(getJsCallJava(),"thunisoftBlockUI",JSON.stringify(params));
    }
    /**
     * 取消华宇logo 加载中
     */
    function thunisoftUnblockUI(){
        mobile.bridgeIOC(getJsCallJava(),"thunisoftUnblockUI");
    }
    /**
     * 初始化pushState
     */
    function initPushState(){
        /**
         * container为selector的规则比如 (#id)、(.class)等
         */
        var pushStateable = true;//在加载了section后判断是否符合pushState原则：出现重复的section，规避代码不规范出现的多次点击和同名section
        app.pagerStartPopState(); //window.addEventListener("popstate")
        app.createPager = function(container){
            var stateSettings = app.stateSettings;
            stateSettings.container = container;//容器缓存起来
            app.stateSettingsParam(app.location.href, stateSettings);//本地全局变量中存储一份
            app.sessionStorage(app.location.href, stateSettings.data);//sessionStorage中存储一份页面pager间传参
        };
        function ajax(){
          var ajaxData = {
            type:arguments[0].type || "GET",
            url:arguments[0].url || "",
            async:arguments[0].async || "true",
            data:arguments[0].data || null,
            dataType:arguments[0].dataType || "text",
            contentType:arguments[0].contentType || "application/x-www-form-urlencoded",
            beforeSend:arguments[0].beforeSend || function(){},
            success:arguments[0].success || function(){},
            error:arguments[0].error || function(){},
            headers:arguments[0].headers || null,
          }
          ajaxData.beforeSend()
          var xhr = new XMLHttpRequest(); 
          xhr.responseType=ajaxData.dataType;
          xhr.open(ajaxData.type,ajaxData.url,ajaxData.async); 
          xhr.setRequestHeader("Content-Type",ajaxData.contentType); 
          for(var header in ajaxData.headers){ 
            xhr.setRequestHeader(header,ajaxData.headers[header]);
          }
          xhr.send(convertData(ajaxData.data)); 
          xhr.onreadystatechange = function() { 
            if (xhr.readyState == 4) { 
              if(xhr.status == 200){
                ajaxData.success(xhr.response)
              }else{
                ajaxData.error()
              } 
            }
          } 
        }
        function convertData(data){
          if( typeof data === 'object' ){
            var convertResult = "" ; 
            for(var c in data){ 
              convertResult+= c + "=" + data[c] + "&"; 
            } 
            convertResult=convertResult.substring(0,convertResult.length-1)
            return convertResult;
          }else{
            return data;
          }
        }
        app.pager = function(container, pagerSettings){
            if(!pagerSettings){
                pagerSettings = app.stateSettings;
            }else{
                //TODO 过滤pagerSettings的字段待定
            }
            var pageUrl = pagerSettings.pageUrl;
            var state = app.getStateObj();
            state.type = "pager";
            recordFrontInfo(pageUrl);
            if(document.querySelectorAll(container).length>0){
                happajax({
                    async:false,
                    url:pageUrl,
                    dataType:'html',
                    headers:{
                        "Pager-Router" : "pager"//配合后台拦截器
                    },
                    success : function(responseText){
                        app.pagerPushPage(container, responseText);
                        //缓存跳转页面传参
                        pagerSettings.container = container;//容器缓存起来
                        pushState(state, pagerSettings);
                        if(pagerSettings.success){
                            pagerSettings.success(responseText, pagerSettings);
                        }
                    },
                    error:function(errorThrown){
                        if(pagerSettings.error){
                            pagerSettings.error(errorThrown, pagerSettings);
                        }
                    }
                });
            }else{
                if(pagerSettings.error){
                    pagerSettings.error("Can't find the container error", pagerSettings);
                }else{
                    console.log("Can't find the container error", pagerSettings);
                }
            }
        };
        function pushState(state, stateSettings){//stateSettings = pagerSettings || routerSettings;
            if(!pushStateable){//不符合入栈pushState，则返回
                return;
            }
            var url = stateSettings.pageUrl;
            var title = stateSettings.title?stateSettings.title:url;
            var titleLL = document.querySelector('title');
            if(titleLL) titleLL.innerHTML= title;
            state.url = url;
            app.stateSettingsParam(url, stateSettings);//本地全局变量中存储一份，即pagerSettings
            app.pagerRequestParams(url, stateSettings.data);//sessionStorage中存储一份页面pager间传参
            if(app.eventListeners.htmlOnStop[app.location.href]){//页面被覆盖前走htmlOnStop
                app.eventListeners.htmlOnStop[app.location.href]();
            }
            if(stateSettings.pushState){//使用pushState处理
                window.history.pushState(state, title, url);//640Kfunction 超！The state object can be anything that can be serialized
            }else{//不使用pushState处理，采用replaceState
                window.history.replaceState(state, title, app.location.href);
            }
            if(app.eventListeners.htmlOnResume[app.location.href]){//新页面要展现了走htmlOnResume
                app.eventListeners.htmlOnResume[app.location.href]();
            }
            app.afterPager();
        }
        //加载page时动画
        app.pagerPushPage = function(container, responseText){
            var temp = document.createElement('div');
            temp.innerHTML = responseText;
            var frag = document.createDocumentFragment();
            while (temp.firstChild) {
                frag.appendChild(temp.firstChild);
            }
            if(document.querySelectorAll(frag.firstChild.id+'-zy').length>1){
                pushStateable = false;//不可压入栈pushState
                console.log("出现重复的section，不能打开新页面，见android-vX.X.X.js中app.pagerPushPage函数注释");
                return;
            }
            var qs_container = document.querySelector(container);
            var children = qs_container.children;
            for(var x=0;x<children.length;x++){
                children[x].style.visibility="hidden";
                children[x].style.overflow="hidden";
                children[x].style.height="0px";
            }
            qs_container.appendChild(frag);
            var qs_section = children[children.length-1];
            qs_section.className = qs_section.id + '-zy';
        };
        //弹出page时动画
        app.pagerPopPage = function(container){
            var qs_container = document.querySelector(container);
            if(qs_container.children.length > 1){
                qs_container.removeChild(qs_container.children[qs_container.children.length-1]);
                var last = qs_container.children[qs_container.children.length-1];
                last.style.removeProperty('height');
                last.style.removeProperty('visibility');
                last.style.removeProperty('overflow');
            }
        };
        //router
        app.router = function(routerSettings){
            if(!routerSettings){
                routerSettings = app.routerSettings;
            }
            if(!routerSettings.activity){
                routerSettings.activity = app.routerType.ROUTER_JS_DEFAULT;
            }
            if(!routerSettings.pushState){
                routerSettings.pushState = "_self";
            }
            var url = routerSettings.url;
            var dataParams = JSON.stringify(routerSettings.data);
            nativeDoMemcache(url,dataParams);
            openNativeActivity(routerSettings.activity, routerSettings, routerSettings.pushState);
        };
    }
    function initEventListener(){
        app.addEventListener = function(params, bubble){
            var url = app.location.href;
            if(!params.url){
                params.url = url;
            }
            if(!params.dataType){
                params.dataType='json';
            }
            if(!params.callback){
                params.callback = function(){};

            }
            registNativeDoEventReceiver(params);
        };
        app.responseEventListener = function(type){//供原生调用
            if(type == app.EventListenersType.BackPress){
                if(app.eventListeners.backPress[app.location.href]){
                    app.eventListeners.backPress[app.location.href]();
                }
            }else if(type == app.EventListenersType.SettingPress){
                if(app.eventListeners.settingPress[app.location.href]){
                    app.eventListeners.settingPress[app.location.href]();
                }
            }else if(type == app.EventListenersType.HtmlOnResume){
                if(app.eventListeners.htmlOnResume[app.location.href]){
                    app.eventListeners.htmlOnResume[app.location.href]();
                }
            }else if(type == app.EventListenersType.HtmlOnStop){
                if(app.eventListeners.htmlOnStop[app.location.href]){
                    app.eventListeners.htmlOnStop[app.location.href]();
                }
            }else if(type == app.EventListenersType.FileChoose){
                if(app.eventListeners.fileChoose[app.location.href]){
                    app.eventListeners.fileChoose[app.location.href](arguments[1]);
                }
            }else if(type == app.EventListenersType.VoiceListener){
                if(app.eventListeners.voiceListener[app.location.href]){
                    app.eventListeners.voiceListener[app.location.href](arguments[1]);
                }
            }else if(type == app.EventListenersType.CollectListener){
                if(app.eventListeners.collectListener[app.location.href]){
                    app.eventListeners.collectListener[app.location.href](JSON.parse(arguments[1]));
                }
            }else if(type == app.EventListenersType.NetworkStatusListener){
                if(app.eventListeners.networkStatusListener[app.location.href]){
                    app.eventListeners.networkStatusListener[app.location.href](arguments[1]);
                }
            }else{
                console.log("response时，没有支持" + params.type + "的监听");
            }
        };
    }
    /**
      * 设置当前的projectName
      */
    function setProjectName(projectName){
        mobile.bridgeIOC(getJsCallJava(),"setProjectName",projectName);
    }
    /**
      * 自定义行为搜集入口
      */
    function recordCustomInfo(jsonParams){
        if(!jsonParams){
            return;
        }
        mobile.bridgeIOC(getJsCallJava(),"recordCustomInfo",JSON.stringify(jsonParams));
    }
    function recordFrontInfo(targetUrl){
        if(!targetUrl){
            return;
        }
        var params = {
            url:targetUrl,
            dataType:app.recordActionType.PAGE_IN,
            pageMessage:''
        }

        if(happjs.TypeJS.isFunction(getJsCallJava().recordFrontInfo)){
            mobile.bridgeIOC(getJsCallJava(),"recordFrontInfo",JSON.stringify(params));
        }
    }
    /**
     * JS调Java接口对象
     */
    function getJsCallJava(){
        return window.HostApp?window.HostApp:"HostApp";
//        try {
//           return HostApp;
//        }catch(err){
//        //ios return 一个未定义的 变量会报错，停止执行
//           return "HostApp";
//        }
    }
    return uiInit();



});
